/*P2-1.c*/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define MAX_NUM_FIELD		1000
#define MAX_NUM_POSITION	1000
#define gamma				2.6751e8

int main(void)
{
	FILE	*fpr1, *fpr2, *fpw1;
	int		i, j;
	int		num_field = 0, num_position = 0;
	int		output_format;
	float	Mx_temp, My_temp, Mz_temp;
	float	R[3][3];
	float	R1, R2, omegaX, omegaY, omegaG, omegaL;
	float	px, py, pz, sinA, cosA;
	float	t = 0.0;
	float	*dt, *RFx, *RFy, *Gx, *Gy, *Gz;
	int		*output;
	float	*x, *y, *z, *T1, *T2, *M0, *Mx, *My, *Mz;

	dt = (float *)malloc(MAX_NUM_FIELD*sizeof(float));
	RFx = (float *)malloc(MAX_NUM_FIELD*sizeof(float));
	RFy = (float *)malloc(MAX_NUM_FIELD*sizeof(float));
	Gx = (float *)malloc(MAX_NUM_FIELD*sizeof(float));
	Gy = (float *)malloc(MAX_NUM_FIELD*sizeof(float));
	Gz = (float *)malloc(MAX_NUM_FIELD*sizeof(float));
	output = (int *)malloc(MAX_NUM_FIELD*sizeof(int));
	x = (float *)malloc(MAX_NUM_POSITION*sizeof(float));
	y = (float *)malloc(MAX_NUM_POSITION*sizeof(float));
	z = (float *)malloc(MAX_NUM_POSITION*sizeof(float));
	T1 = (float *)malloc(MAX_NUM_POSITION*sizeof(float));
	T2 = (float *)malloc(MAX_NUM_POSITION*sizeof(float));
	M0 = (float *)malloc(MAX_NUM_POSITION*sizeof(float));
	Mx = (float *)malloc(MAX_NUM_POSITION*sizeof(float));
	My = (float *)malloc(MAX_NUM_POSITION*sizeof(float));
	Mz = (float *)malloc(MAX_NUM_POSITION*sizeof(float));

	// field.txtǂݏoD

	if ((fpr1 = fopen("field.txt", "r")) == NULL) {
		fprintf(stderr, "Error: file open [field.txt]\n");
		exit(1);
	}

	while (fscanf(fpr1, "%f\t%f\t%f\t%f\t%f\t%f\t%d", &dt[num_field], &RFx[num_field], &RFy[num_field], &Gx[num_field], &Gy[num_field], &Gz[num_field], &output[num_field]) != EOF)
		num_field++;

	fclose(fpr1);

	printf("%d lines in field.txt\n", num_field);

	// position.txtǂݏoD

	if ((fpr2 = fopen("position.txt", "r")) == NULL) {
		fprintf(stderr, "Error: file open [position.txt]\n");
		exit(1);
	}

	while (fscanf(fpr2, "%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f", &x[num_position], &y[num_position], &z[num_position], &T1[num_position], &T2[num_position], &M0[num_position], &Mx[num_position], &My[num_position], &Mz[num_position]) != EOF)
		num_position++;

	fclose(fpr2);

	printf("%d lines in position.txt\n", num_position);

	// ʂo͂邽߁Cresult.csvJD

	if ((fpw1 = fopen("result.csv", "w")) == NULL) {
		fprintf(stderr, "Error: file open [result.csv]\n");
		exit(1);
	}

	// 1Ԃ܂2Ԃ̏o͌`ID

	do {
		printf("Output format? (1: distribution of final magnetization, 2: time course of total magnetization)\n");
		scanf("%d", &output_format);
	} while (output_format != 1 && output_format != 2);

	for (i = 0; i < num_field; i++) {
		for (j = 0; j < num_position; j++) {
			R1 = 1.0/T1[j];
			R2 = 1.0/T2[j];
			omegaX = -gamma*RFx[i]*1.0e-6;
			omegaY = -gamma*RFy[i]*1.0e-6;
			omegaG = -gamma*(Gx[i]*x[j]+Gy[i]*y[j]+Gz[i]*z[j])*1.0e-3;

			// RFƎ˂ĂȂƂC(2-30)𗘗pD

			if (RFx[i] == 0.0 && RFy[i] == 0.0) {
				R[0][0] = exp(-R2*dt[i])*cos(omegaG*dt[i]);
				R[0][1] = -exp(-R2*dt[i])*sin(omegaG*dt[i]);
				R[0][2] = 0.0;
				R[1][0] = -R[0][1];
				R[1][1] = R[0][0];
				R[1][2] = 0.0;
				R[2][0] = 0.0;
				R[2][1] = 0.0;
				R[2][2] = exp(-R1*dt[i]);
			}

			else {

				// (2-12)ŗ^pxCpyCpzvZD

				omegaL = sqrt(omegaX*omegaX+omegaY*omegaY+omegaG*omegaG);
				px = omegaX/omegaL;
				py = omegaY/omegaL;
				pz = omegaG/omegaL;

				sinA = sin(dt[i]*omegaL);
				cosA = cos(dt[i]*omegaL);

				// RFƎ˂ĂƂC(2-14)𗘗pD

				R[0][0] = (1.0-cosA)*px*px+cosA;
				R[0][1] = px*py*(1.0-cosA)-pz*sinA;
				R[0][2] = px*pz*(1.0-cosA)+py*sinA;
				R[1][0] = px*py*(1.0-cosA)+pz*sinA;
				R[1][1] = (1.0-cosA)*py*py+cosA;
				R[1][2] = py*pz*(1.0-cosA)-px*sinA;
				R[2][0] = px*pz*(1.0-cosA)-py*sinA;
				R[2][1] = py*pz*(1.0-cosA)+px*sinA;
				R[2][2] = (1.0-cosA)*pz*pz+cosA;
			}

			// (2-9)܂(2-22)ɂCxNgXVD

			Mx_temp = Mx[j];
			My_temp = My[j];
			Mz_temp = Mz[j];

			Mx[j] = R[0][0]*Mx_temp+R[0][1]*My_temp+R[0][2]*Mz_temp;
			My[j] = R[1][0]*Mx_temp+R[1][1]*My_temp+R[1][2]*Mz_temp;
			Mz[j] = R[2][0]*Mx_temp+R[2][1]*My_temp+R[2][2]*Mz_temp;

			// (2-22)̉Eӑ2D

			if (RFx[i] == 0.0 && RFy[i] == 0.0)
				Mz[j] += (1.0-R[2][2])*M0[j];
		}

		t += dt[i];

		// o͌`2ԂI񂾏ꍇ̌ʏ݁D

		if (output_format == 2 && output[i] == 1) {
			fprintf(fpw1, "%f,", t);
			Mx_temp = 0.0;
			My_temp = 0.0;
			Mz_temp = 0.0;
			for (j = 0; j < num_position; j++) {
				Mx_temp += Mx[j];
				My_temp += My[j];
				Mz_temp += Mz[j];
			}
			fprintf(fpw1, "%f,%f,%f\n", Mx_temp, My_temp, Mz_temp);
		}
	}

	// o͌`1ԂI񂾏ꍇ̌ʏ݁D

	if (output_format == 1)
		for (j = 0; j < num_position; j++)
			fprintf(fpw1, "%f,%f,%f,%f,%f,%f\n", x[j], y[j], z[j], Mx[j], My[j], Mz[j]);

	fclose(fpw1);

	return 0;
}