/*P3-11.c*/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define PI		3.1415926535898
#define N		150					//ԃXebv
#define	A		1.0					//x1Ƃ
#define	D		2.0e-6				//gUW(mm^2/ms)
#define	a		-0.5
#define	b		0.5
#define	alpha	2.0*PI
#define	gamma	42.58*2.0*PI		//(rad/ms/mT)
#define	rx		0.75				//o͔͈(̒l)
#define	dt		1.0

int main(void)
{
	char	fo[50];
	int		i, j, m;
	double	t, dx, s, dif_tim, x, G, phi;
	double	u[3][N], dum[3][N], Mx[2], My[2];
	FILE	*fp1, *fp2;

//̓
	printf("MPGx [mT/mm] = ");
	scanf("%lf", &G);
	printf(" t[ms] = ");
	scanf("%lf", &dif_tim);
	dx = 2.0*rx/N;
	printf("ԊԊu dt[ms] = %.3f\n", dt);
	printf("ԊԊu dx[mm] = %.3f\n", dx);

//
	for (i = 0; i < 3; i++) {
		for (j = 0; j < N; j++) {
			u[i][j] = 0;
			dum[i][j] = 0;
		}
	}

	for (j = 0; j < N; j++) {
		x = (j-N/2)*dx;
		if (a <= x && x <= b) {
			u[0][j] = A*cos(alpha*x);							//0:	
			u[1][j] = A*sin(alpha*x);							//1:
			u[2][j] = sqrt(u[0][j]*u[0][j]+u[1][j]*u[1][j]);	//2:x
		}
	}

//̏o
	sprintf(fo, "kukei_t=0.csv");
	printf("o̓t@C >> %s\n", fo);
	if ((fp1 = fopen(fo, "w")) == NULL) {
		fprintf(stderr, "file open error[%s]\n", fo);
		exit(1);
	}
	fprintf(fp1, "x [mm],Re,Im,Amp\n");
	for (j = 0; j < N; j++)
		fprintf(fp1, "%.2f,%.2f,%.2f,%.2f\n", (j-N/2)*dx, u[0][j], u[1][j], u[2][j]);
	fclose(fp1);

//L@ɂgǓvZ
	s = D*dt/dx/dx;
	printf("s = %.2f\n", s);
	if (s > 0.5) {				//s0.5傫ƂI
		exit(1);
	}

	for (t = dt; t <= dif_tim; t += dt) {
		printf("\r\tt = %.2f", t);
//gU
		for (m = 0; m < N; m++) {
			if (m == 0) {
				Mx[0] = 0;
				Mx[1] = u[0][m+1];
				My[0] = 0.0;
				My[1] = u[1][m+1];
			}
			else if (m == N-1) {
				Mx[0] = u[0][m-1];
				Mx[1] = 0;
				My[0] = u[1][m-1];
				My[1] = 0;
			}
			else {
				Mx[0] = u[0][m-1];
				Mx[1] = u[0][m+1];
				My[0] = u[1][m-1];
				My[1] = u[1][m+1];
			}
			dum[0][m] = s*Mx[0]+s*Mx[1]+(1.-s-s)*u[0][m];
			dum[1][m] = s*My[0]+s*My[1]+(1.-s-s)*u[1][m];
		}
//ʑω
		for (m = 0; m < N; m++) {
			phi = -gamma*G*(m-N/2)*dx*dt;
			u[0][m] = dum[0][m]*cos(phi)-dum[1][m]*sin(phi);		//
			u[1][m] = dum[0][m]*sin(phi)+dum[1][m]*cos(phi);		//
			u[2][m] = sqrt(u[0][m]*u[0][m]+u[1][m]*u[1][m]);		//x
		}
	}
	printf("\n");

//o
	sprintf(fo, "kukei_t=%.0f_G=%.4f.csv", dif_tim, G);
	printf("o̓t@C >> %s\n", fo);
	if ((fp2 = fopen(fo, "w")) == NULL) {
		fprintf(stderr, "file open error[%s]\n", fo);
		exit(1);
	}

	printf("x [mm]\tRe\tIm\tAmp\n");
	fprintf(fp2, "x [mm],Re,Im,Amp\n");
	for (j = 0; j < N; j++) {
		printf("%.3f\t%.3f\t%.3f\t%.3f\n", (j-N/2)*dx, u[0][j], u[1][j], u[2][j]);
		fprintf(fp2, "%.3f,%.3f,%.3f,%.3f\n", (j-N/2)*dx, u[0][j], u[1][j], u[2][j]);
	}
	fclose(fp2);

	return 0;
}