/*P3-9.c*/

#include <stdio.h>
#include <stdlib.h>
#include <math.h> 

#define PI		3.1415926535898
#define NC		100000
#define	A		1.0				//x1Ƃ
#define	D		2.0e-6			//gUW[mm^2/ms]
#define	a		-0.5
#define	b		0.5
#define	alpha	2.0*PI			//=2
#define	gamma	42.58*2.0*PI	//(rad/ms/mT)
#define	G		1.0e-3			//XΎꋭx(mT/mm)
#define	rx		0.6
#define	nx		120

void complex_erf(double *re, double *im) {

	int		i;
	double	sum1, sum2, t, aa, bb;

	aa = *re;
	bb = *im;

	t = 0.0;
	sum1 = 0.0;
	sum2 = 0.0;
	for (i = 0; i < NC; i++) {
		t += bb/NC;
		sum1 += exp(t*t)*sin(2.0*aa*t)*bb/NC;
		sum2 += exp(t*t)*cos(2.0*aa*t)*bb/NC;
	}
	*re = erf(aa)+2.0/sqrt(PI)*exp(-aa*aa)*sum1;
	*im = 2.0/sqrt(PI)*exp(-aa*aa)*sum2;
}

int main(void) 
{
	char	fo[50];
	int		i, ic;
	double	t, dx, x, k, th, re, im, amp;
	double	re_a, im_a, re_b, im_b, e_re, e_im;
	FILE	*fp;

//
	printf("t [ms] = ");
	scanf("%lf", &t);
	dx = 2.0*rx/nx;
	printf("dx [mm] = %.3f\n", dx);
	ic = nx/2;						//SObhʒu

//t@C̃I[v
	sprintf(fo, "kukei_mpg_t=%.0f.csv", t);
	printf("Output filename >> %s\n", fo);
	if ((fp = fopen(fo, "w")) == NULL) {
		fprintf(stderr, "file open error[%s]\n", fo);
		exit(1);
	}

//vZяo
	printf("x [mm]\tRe\tIm\tAmp\n");
	fprintf(fp, "x [mm],Re,Im,Amp\n");
	for (i = 0; i < nx; i++) {
		x = (i-ic)*dx;
		re_a = (x-a)/sqrt(4.0*D*t);
		im_a = sqrt(D*t)*(2.0*alpha-gamma*G*t)/2.0;
		complex_erf(&re_a, &im_a);						//t^J
		re_b = (x-b)/sqrt(4.0*D*t);
		im_b = sqrt(D*t)*(2.0*alpha-gamma*G*t)/2.0;
		complex_erf(&re_b, &im_b);						//t^J
		e_re = re_a-re_b;								//ErěvZ
		e_im = im_a-im_b;								//Eim̌vZ
		k = A/2.0*exp(-D*t*(alpha*alpha-gamma*G*t*(alpha-gamma*G*t/3.0)));	//W
		th = (alpha-gamma*G*t)*x;					
		re = k*(e_re*cos(th)-e_im*sin(th));				//(3-59) 
		im = k*(e_re*sin(th)+e_im*cos(th));				//(3-60) 
		amp = sqrt(re*re+im*im);						//x
		printf("%.3f\t%.3f\t%.3f\t%.3f\n", x, re, im, amp);
		fprintf(fp, "%.3f,%.3f,%.3f,%.3f\n", x, re, im, amp);
	}

	fclose(fp);
	return 0;
}

