/*P5-1.c*/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define	IMG			128
#define	MPG			6
#define b			986.0
#define THRESHOLD	0.005

void read_data_float(char *, float *, int);		//֐̃vg^Cv錾
void write_data_float(char *, float *, int);

int main(void)
{
	char  fi[50], fo[50];
	int	  i, m;
	float *g0, *mpg, *adc;

	g0 = (float *)malloc(IMG*IMG*sizeof(float));
	mpg = (float *)malloc(IMG*IMG*MPG*sizeof(float));
	adc = (float *)malloc(IMG*IMG*MPG*sizeof(float));

//read data
	read_data_float("G0.img", g0, IMG*IMG);

	for (m = 0; m < MPG; m++) {
		sprintf(fi, "G%d.img", m+1);
		read_data_float(fi, mpg+m*IMG*IMG, IMG*IMG);
	}

//ADCľvZ
	for (m = 0; m < MPG; m++) {
 		for (i = 0; i < IMG*IMG; i++) {
			if (g0[i] > THRESHOLD)
				adc[m*IMG*IMG+i] = -log(mpg[m*IMG*IMG+i]/g0[i])/b;
			else
				adc[m*IMG*IMG+i] = 0;
		}
		sprintf(fo, "ADC%d.img", m+1);
		write_data_float(fo, adc+m*IMG*IMG, IMG*IMG);
	}
	return 0;
}

void read_data_float(char *fi, float *img, int size) /*file open and read data*/
{
	FILE   *fp;
	printf("read data : %s\n",fi);	

	if((fp = fopen(fi, "rb")) == NULL) {
		fprintf( stderr," Error : file open [%s].\n", fi);
		exit(1);
	}
	fread(img, sizeof(float), size, fp);
	fclose(fp);
}

void write_data_float(char *fi,float *im,int size)	/*file open and write data*/
{	
	FILE  *fp;
	printf("write data : %s\n",fi);	

	if ((fp=fopen(fi,"wb"))==NULL){
		fprintf(stderr, "Error :file open[%s] \n",fi);
		exit(1);
	}
	fwrite(im,sizeof(float),size,fp);
	fclose(fp);
}
