/*P5-2.c*/

#include <stdio.h>
#include <stdlib.h>
#include <math.h> 

#define	IMG			128
#define	MPG			6
#define b			986.0
#define THRESHOLD	0.005

void read_data_float(char *, float *, int);		//֐̃vg^Cv錾
void write_data_float(char *, float *, int);
int jacobi(float in[][3], float *, float v[][3]);
void sort(int, int, float *, float v[][3]);

int main(void)
{
	char	fi[50], fo[50];
	int		i, j, k, m;
	float	f, sum, sum2, dlam2;
	float	*g0, *mpg, *lam, *epsilon, *md, *fa, *red, *green, *blue;
	float	DT[3][3];
	float	d[3];
	float	Q[3][3];
	float	IM[MPG];

	g0 = (float *)malloc(IMG*IMG*sizeof(float));
	mpg = (float *)malloc(IMG*IMG*MPG*sizeof(float));
	lam = (float *)malloc(IMG*IMG*3*sizeof(float));
	epsilon = (float *)malloc(IMG*IMG*3*sizeof(float));
	md = (float *)malloc(IMG*IMG*sizeof(float));
	fa = (float *)malloc(IMG*IMG*sizeof(float));
	red = (float *)malloc(IMG*IMG*sizeof(float));
	green = (float *)malloc(IMG*IMG*sizeof(float));
	blue = (float *)malloc(IMG*IMG*sizeof(float));

//read data
	read_data_float("G0.img", g0, IMG*IMG);

	for (m = 0; m < MPG; m++) {
		sprintf(fi, "G%d.img", m+1);
		read_data_float(fi, mpg+m*IMG*IMG, IMG*IMG);
	}

//tensor
	for (i = 0; i < IMG*IMG; i++) {
		if (g0[i] > THRESHOLD) {
			for (m = 0; m < MPG; m++)
				IM[m] = log(mpg[m*IMG*IMG+i]/g0[i]);						//(5-34)ɂ́iOUCǰvZ
			DT[0][0] = (-IM[0]-IM[1]+IM[2]+IM[3]-IM[4]-IM[5])/(2.0*b);		//Dxx̌vZ
			DT[1][1] = ( IM[0]+IM[1]-IM[2]-IM[3]-IM[4]-IM[5])/(2.0*b);		//Dyy̌vZ
			DT[2][2] = (-IM[0]-IM[1]-IM[2]-IM[3]+IM[4]+IM[5])/(2.0*b);		//DzžvZ
			DT[0][1] = DT[1][0]=(-IM[4]+IM[5])/(2.0*b);						//Dxy̌vZ
			DT[1][2] = DT[2][1]=(-IM[2]+IM[3])/(2.0*b);						//DyžvZ
			DT[0][2] = DT[2][0]=(-IM[0]+IM[1])/(2.0*b);						//Dzx̌vZ

			for (j = 0; j < 3; j++)
				for (k = 0; k < 3; k++) {
					if (j == k)
						Q[j][k] = 1.0;
					else
						Q[j][k] = 0.0;
				}

			jacobi(DT, d, Q);

			sort(0, 1, d, Q);
			sort(0, 2, d, Q);
			sort(1, 2, d, Q);

			for (j = 0; j < 3; j++) {
				lam[j*IMG*IMG+i] = d[j];
				epsilon[j*IMG*IMG+i] = Q[j][0];
			}

		}
		else {
			for (j = 0; j < 3; j++)
				lam[j*IMG*IMG+i] = 0.0;
		}
	}
	for (j = 0; j < 3; j++) {
		sprintf(fo, "lam%d.img", j+1);
		write_data_float(fo, lam+j*IMG*IMG, IMG*IMG);
	}

//MD&FA
	for (i = 0; i < IMG*IMG; i++) {
		if (g0[i] > THRESHOLD) {
			sum = 0.0;
			dlam2 = 0.0;
			sum2 = 0.0;
			for (j = 0; j < 3; j++)
				sum += lam[j*IMG*IMG+i];
			md[i] = sum/3.0;
			for (j = 0; j < 3; j++) {
				dlam2 += (lam[j*IMG*IMG+i]-md[i])*(lam[j*IMG*IMG+i]-md[i]);
				sum2 += lam[j*IMG*IMG+i]*lam[j*IMG*IMG+i];
			}
			fa[i] = sqrt(3.0*dlam2/(2.0*sum2));
		}
		else {
			md[i] = 0.0;
			fa[i] = 0.0;
		}
	}
	write_data_float("MD.img", md, IMG*IMG);
	write_data_float("FA.img", fa, IMG*IMG);

//color map
	for (i = 0; i < IMG*IMG; i++) {
		if (g0[i] > THRESHOLD) {
			red[i] = fa[i]*fabs(epsilon[i]);
			green[i] = fa[i]*fabs(epsilon[IMG*IMG+i]);
			blue[i] = fa[i]*fabs(epsilon[IMG*IMG*2+i]);
		}
		else {
			red[i] = 0.0;
			green[i] = 0.0;
			blue[i] = 0.0;
		}
	}
	write_data_float("red.img", red, IMG*IMG);
	write_data_float("green.img", green, IMG*IMG);
	write_data_float("blue.img", blue, IMG*IMG);

	return 0;
}

void read_data_float(char *fi, float *img, int size) /*file open and read data*/
{
	FILE   *fp;

	printf("read data : %s\n", fi);	

	if ((fp = fopen(fi, "rb")) == NULL) {
		fprintf(stderr, "Error : file open [%s].\n", fi);
		exit(1);
	}
	fread(img, sizeof(float), size, fp);
	fclose(fp);
}

void write_data_float(char *fi, float *im, int size)	/*file open and write data*/
{	
	FILE  *fp;

	printf("write data : %s\n", fi);	

	if ((fp = fopen(fi, "wb")) == NULL) {
		fprintf(stderr, "Error :file open[%s] \n", fi);
		exit(1);
	}
	fwrite(im, sizeof(float), size, fp);
	fclose(fp);
}

int jacobi(float in[][3], float *d, float v[][3])
{
	float	h, u, c, s, t;
	int		j = 0, k;
	float	dum_v[3];

	while (2.0*(in[0][1]*in[0][1]+in[0][2]*in[0][2]+in[1][2]*in[1][2]) > fabs(in[0][0]+in[1][1]+in[2][2])/1.0e5){	// (5-31)̏I
		if (in[0][1] != 0.0) {
			h = (in[1][1]-in[0][0])/2.0/in[0][1];		// (5-27)
			if (h == 0.0)
				u = 1.0;
			else if (fabs(h) < 1.0e5)
				u = h/fabs(h)/(fabs(h)+sqrt(h*h+1.0));	// (5-29)
			else
				u = 0.5/h;								// (5-30)
			c = 1.0/sqrt(u*u+1.0);
			s = u*c;									// (5-17)
			t = (sqrt(u*u+1.0)-1.0)/u;					// (5-17)

			in[0][0] -= u*in[1][0];						// (5-14)ɂJacobi]
			in[1][1] += u*in[1][0];
			in[0][1] = 0.0;
			in[1][2] += s*(in[2][0]-t*in[2][1]);
			in[0][2] -= s*(in[2][1]+t*in[2][0]);
			in[1][0] = 0.0;
			in[2][1] = in[1][2];
			in[2][0] = in[0][2];

			for (k = 0; k < 3; k++) {
				dum_v[k] = v[k][0];
				v[k][0] = c*dum_v[k]-s*v[k][1];
				v[k][1] = s*dum_v[k]+c*v[k][1];
			}
		}

		if (in[1][2] != 0.0) {
			h = (in[2][2]-in[1][1])/2.0/in[1][2];		// (5-27)
			if (h == 0.0)
				u = 1.0;
			else if (fabs(h) < 1.0e5)
				u = h/fabs(h)/(fabs(h)+sqrt(h*h+1.0));	// (5-29)
			else
				u = 0.5/h;								// (5-30)
			c = 1.0/sqrt(u*u+1.0);
			s = u*c;									// (5-17)
			t = (sqrt(u*u+1.0)-1.0)/u;					// (5-17)

			in[1][1] -= u*in[2][1];						// (5-15)ɂJacobi]
			in[2][2] += u*in[2][1];
			in[0][1] -= s*(in[2][0]+t*in[1][0]);
			in[1][2] = 0.0;
			in[0][2] += s*(in[1][0]-t*in[2][0]);
			in[1][0] = in[0][1];
			in[2][1] = 0.0;
			in[2][0] = in[0][2];

			for (k = 0; k < 3; k++) {
				dum_v[k] = v[k][1];
				v[k][1] = c*dum_v[k]-s*v[k][2];
				v[k][2] = s*dum_v[k]+c*v[k][2];
			}
		}

		if (in[0][2] != 0.0) {
			h = (in[2][2]-in[0][0])/2.0/in[0][2];		// (5-27)
			if (h == 0.0)
				u = 1.0;
			else if (fabs(h) < 1.0e5)
				u = h/fabs(h)/(fabs(h)+sqrt(h*h+1.0));	// (5-29)
			else
				u = 0.5/h;								// (5-30)
			c = 1.0/sqrt(u*u+1.0);
			s = u*c;									// (5-17)
			t = (sqrt(u*u+1.0)-1.0)/u;					// (5-17)

			in[0][0] -= u*in[2][0];						// (5-16)ɂJacobi]
			in[2][2] += u*in[2][0];
			in[0][1] -= s*(in[2][1]+t*in[1][0]);
			in[1][2] += s*(in[1][0]-t*in[2][1]);
			in[0][2] = 0.0;
			in[1][0] = in[0][1];
			in[2][1] = in[1][2];
			in[2][0] = 0.0;

			for (k = 0; k < 3; k++) {
				dum_v[k] = v[k][0];
				v[k][0] = c*dum_v[k]-s*v[k][2];
				v[k][2] = s*dum_v[k]+c*v[k][2];
			}
		}

		j++;
		if (j > 100) {
			fprintf(stderr, "Error : too many iterations.\n");
			for (k = 0; k < 3; k++)
				d[k] = in[k][k];
			return 0;
		}
	}
	for (k = 0; k < 3; k++)
		d[k] = in[k][k];
	return 1;
}

void sort(int pos1, int pos2, float *d, float v[][3])
{
	int		i;
	float	p;

	if (d[pos1] < d[pos2]) {
		p = d[pos1];
		d[pos1] = d[pos2];
		d[pos2] = p;

		for (i = 0; i < 3; i++) {
			p = v[i][pos1];
			v[i][pos1] = v[i][pos2];
			v[i][pos2] = p;
		}
	}
}