/*P6-1.c*/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>

#define PI				3.1415926535898
#define GAMMA			42.58 * 2.0 * PI	//C](rad/ms/mT)
#define NCS				9					//זE̍sC
#define ICS				15.0				//זȆ傫 (m)
#define ICF				0.78				//זE߂銄
#define NG				5					//XΎ̓̓f[^
#define MPG_WIDTH		25.0				//MPG̃pX (ms)
#define MPG_INTERVAL	50.0				//MPG̃pXԊu (ms)
#define TE				75.0				//Echo Time (ms)
#define DELTA_T			0.01				//tFԃXebv (ms)
#define DELTA_X			0.5					//xFԃXebv (m):sNZTCY
#define TH				0.0					//MPG̈[degree]
#define NCA				3					//MW͈

void write_data_float(char *, float *, int);
float s_cal(float , float , float , float , float);

int main(void)
{
	FILE	*fp1, *fp2, *fpr1, *fpr2;
	char	fot1[100], fot2[50], title[100];
	int		i, m, n, len_int, len_ext, len_cel, count, count1, IMG, len_h_ext, n_cal, gg, cs, cl;
	float	d, j, p_int, b, t, phi, Gx, Gy, sig_x, sig_y, sig_0, sig_TE, D_ext, D_int, P, De, Di_i, Di_l, Di_s, P_i, P_l, P_s, PP;
	float	G[NG];
	float	*img_c, *img_D, *Mx, *My, *Mm, *dum_Mx, *dum_My, *s_up, *s_down, *s_left, *s_right, *s_rem, *sin_phi, *cos_phi;

//f[^̓
	if ((fpr1 = fopen("P6-1_input.txt", "r")) == NULL) {
		fprintf(stderr, "Error :file open [P6-1_input.txt]\n");
		exit(1);
	}
	fgets(title, 100, fpr1);
	printf("%s", title);
	fscanf(fpr1, "%f\t%f\t%f\t%f\t%f\t%f\t%f", &De, &Di_i, &Di_l, &Di_s, &P_i, &P_l, &P_s);
	printf("%.1f\t%.1f\t%.1f\t%.1f\t%.1f\t%.1f\t%.1f\n", De, Di_i, Di_l, Di_s, P_i, P_l, P_s);
	D_ext = De;
//s_ext<0.25
	if (0.25 < D_ext*DELTA_T/(DELTA_X*DELTA_X)) {			
		printf("s_ext: %.2f > 0.25 \n", D_ext*DELTA_T/(DELTA_X*DELTA_X));
		exit(1);
	}

	if ((fpr2 = fopen("P6-1_g_5.txt", "r")) == NULL) {
		fprintf(stderr, "Error :file open [P6-1_g_5.txt]\n");
		exit(1);
	}
	printf("\ngg   G [mT/m]\n");
	for (gg = 0; gg < NG; gg++) {
		fscanf(fpr2, "%f", &G[gg]);
		printf("%d >> %.3f\n", gg, G[gg]);
		G[gg] *= 1.0e-6;									//x:(mT/m) -> (mT/m)
	}

	len_int = floor(ICS/DELTA_X+0.5);						//זȆ傫			(pixel)
	len_ext = floor(sqrt(len_int*len_int/ICF)-len_int+0.5);	//זEȎ傫		(pixel)
	len_h_ext = len_ext/2;									//זEO̔̑傫	(pixel)
	len_cel = len_int+len_ext;								//ׂ̍זE܂ł̋	(pixel)
	IMG = len_cel*NCS;										//m[h
	p_int = (float)len_int*len_int*NCS*NCS/IMG/IMG*100;		//זEOԂ߂銄	(%)
    n_cal = TE/DELTA_T;										//vZ
	cs = len_cel*(NCS-NCA)/2;								//MWJn_
	cl = cs+len_cel*NCA;									//MWI_

//̊m
	img_c = (float *)malloc(IMG*IMG*sizeof(float));			//זĚ`摜
	img_D = (float *)malloc(IMG*IMG*sizeof(float));			//gUW摜
	Mx = (float *)malloc(IMG*IMG*sizeof(float));			//̎
	My = (float *)malloc(IMG*IMG*sizeof(float));			//̋
	Mm = (float *)malloc(IMG*IMG*sizeof(float));			//̑傫
	dum_Mx = (float *)malloc(IMG*IMG*sizeof(float));		//̎̃_~[
	dum_My = (float *)malloc(IMG*IMG*sizeof(float));		//̋̃_~[
	s_up = (float *)malloc(IMG*IMG*sizeof(float));			//ړ
	s_down = (float *)malloc(IMG*IMG*sizeof(float));		//ړ
	s_left = (float *)malloc(IMG*IMG*sizeof(float));		//ړ
	s_right = (float *)malloc(IMG*IMG*sizeof(float));		//Eړ
	s_rem = (float *)malloc(IMG*IMG*sizeof(float));			//Ƃ̊iq_Ɏc銄
	sin_phi = (float *)malloc(IMG*IMG*sizeof(float));		//ʑω̐
	cos_phi = (float *)malloc(IMG*IMG*sizeof(float));		//ʑω̗]

	for (D_int = Di_i; D_int <= Di_l; D_int += Di_s) {
		for (PP = P_i; PP <= P_l; PP += P_s) {
			P = PP*1.0e-3;								//(m/s)

//s_int<0.25
			if (0.25 < D_int*DELTA_T/(DELTA_X*DELTA_X)) {			
				printf("s_int: %.2f > 0.25 \n", D_int*DELTA_T/(DELTA_X*DELTA_X));
				exit(1);
			}

//eLXgւ̏̏
			sprintf(fot1, "output_De%.2f_Di%.2f_P%.0f.txt", D_ext, D_int, P*1.0e3);
			if ((fp1 = fopen(fot1, "w")) == NULL) {
				fprintf(stderr, "Error :file open \n");
				exit(1);
			}
			sprintf(fot2, "signal_De%.2f_Di%.2f_P%.0f.txt", D_ext, D_int, P*1.0e3);
			if ((fp2 = fopen(fot2, "w")) == NULL) {
				fprintf(stderr, "Error :file open \n");
				exit(1);
			}

//זEfƊgUW̉摜
			for (i = 0; i < IMG*IMG; i++) {				
				img_c[i] = 100.0;
				img_D[i] = D_int;
			}
			for (n = 0; n < IMG; n++) {
				for (m = 0; m < IMG; m++) {
					if ((n%len_cel) < len_h_ext || (n%len_cel) > len_h_ext+len_int) {
						img_c[n*IMG+m] = 0.0;
						img_D[n*IMG+m] = D_ext;
					}
					if ((m%len_cel) < len_h_ext || (m%len_cel) > len_h_ext+len_int) {
						img_c[n*IMG+m] = 0.0;
						img_D[n*IMG+m] = D_ext;
					}
				}
			}
//			write_data_float("cell.img", img_c, IMG*IMG);
//			write_data_float("D.img", img_D, IMG*IMG);
	
//d = D_int/D_extj = s_mem/s_exťvZ
			if (D_ext == 0)
				d = 0;
			else
				d = D_int/D_ext;
			if (2*D_ext*D_int+P*DELTA_X*(D_ext+D_int) == 0)
				j = 0;
			else
				j = 2*P*D_int*DELTA_X/(2*D_ext*D_int+P*DELTA_X*(D_ext+D_int));	//	j = s_mem/s_ext

//ړ̌vZ
			for (n = 0; n < IMG; n++) {
				for (m = 0; m < IMG; m++) {
					if (n != 0)
						s_up[n*IMG+m] = s_cal(img_c[n*IMG+m], img_c[(n-1)*IMG+m], img_D[n*IMG+m], img_D[(n-1)*IMG+m], j);
					else
						s_up[n*IMG+m] = 0.0;
					if (n != IMG-1)
						s_down[n*IMG+m] = s_cal(img_c[n*IMG+m], img_c[(n+1)*IMG+m], img_D[n*IMG+m], img_D[(n+1)*IMG+m], j);
					else
						s_down[n*IMG+m] = 0.0;
					if (m != 0)
						s_left[n*IMG+m] = s_cal(img_c[n*IMG+m], img_c[n*IMG+m-1], img_D[n*IMG+m], img_D[n*IMG+m-1], j);
					else
						s_left[n*IMG+m] = 0.0;
					if (m != IMG-1)
						s_right[n*IMG+m] = s_cal(img_c[n*IMG+m], img_c[n*IMG+m+1], img_D[n*IMG+m], img_D[n*IMG+m+1], j);
					else
						s_right[n*IMG+m] = 0.0;
		
					s_rem[n*IMG+m] = 1.0-s_up[n*IMG+m]-s_down[n*IMG+m]-s_left[n*IMG+m]-s_right[n*IMG+m];
				}
			}

//̏o
			printf("////CONDITIONS////\n");
			printf("\tזEO̊gUW D_ext = %.2f [~10^-3 mm^2/s]\n", D_ext);
			printf("\tזE̊gUW D_int = %.2f [~10^-3 mm^2/s]\n", D_int);
			printf("\tԊԊu dt = %.2f [ms]\n", DELTA_T);
			printf("\tԊԊu dx = %.2f [m]\n", DELTA_X);
			printf("\tMPGpX  = %.2f [ms]\n", MPG_WIDTH);
			printf("\tMPGԊu  = %.2f [ms]\n", MPG_INTERVAL);
			printf("\tזËӂ̑傫 = %d [pixel] = %.2f [m]\n", len_int, (float)len_int*DELTA_X);
			printf("\tזEO = %d [pixel] = %.2f [m]\n", len_ext, (float)len_ext*DELTA_X);
			printf("\tזEԁFזEO = %.2f [%%]F%.2f [%%]\n", p_int, 100.0-p_int);
			printf("\tזE̔z = %d~%d\n", NCS, NCS);
			printf("\tvZ = %d [times]\n", n_cal);
			printf("\tזEO̊gU̕ψړ = %.2f [m]\n", sqrt(2.0*D_ext*DELTA_T));
			printf("\tזE̊gU̕ψړ = %.2f [m]\n", sqrt(2.0*D_int*DELTA_T));
			printf("\tiq_ = %d \n", IMG);
			printf("\tMWJniq_ = %d \n", cs);
			printf("\tMWIiq_ = %d \n", cl);
			printf("\tP = %.2f [m/s]\n", P*1.0e3);
			printf("\t = %.1f [degree] \n", TH);
			printf("\td = D_int/D_ext = %.3f\n", d);
			printf("\tj = s_mem/s_ext = %.3f\n", j);
			printf("\ts_int = %.3f\n", D_int*DELTA_T/(DELTA_X*DELTA_X));
			printf("\ts_ext = %.3f\n", D_ext*DELTA_T/(DELTA_X*DELTA_X));
			printf("\ts_mem = %.3f\n", D_ext*DELTA_T/(DELTA_X*DELTA_X)*j);

//eLXgւ̏̏
			fprintf(fp1, "////CONDITIONS////\n");
			fprintf(fp1, "\tזEO̊gUW D_ext = %.2f [~10^-3 mm^2/s]\n", D_ext);
			fprintf(fp1, "\tזE̊gUW D_int = %.2f [~10^-3 mm^2/s]\n", D_int);
			fprintf(fp1, "\tԊԊu dt = %.2f [ms]\n", DELTA_T);
			fprintf(fp1, "\tԊԊu dx = %.2f [m]\n", DELTA_X);
			fprintf(fp1, "\tMPGpX  = %.2f [ms]\n", MPG_WIDTH);
			fprintf(fp1, "\tMPGԊu  = %.2f [ms]\n", MPG_INTERVAL);
			fprintf(fp1, "\tזËӂ̑傫 = %d [pixel] = %.2f [m]\n", len_int, (float)len_int*DELTA_X);
			fprintf(fp1, "\tזEO = %d [pixel] = %.2f [m]\n", len_ext, (float)len_ext*DELTA_X);
			fprintf(fp1, "\tזEԁFזEO = %.2f [%%]F%.2f [%%]\n", p_int, 100.0-p_int);
			fprintf(fp1, "\tזE̔z = %d~%d\n", NCS, NCS);
			fprintf(fp1, "\tvZ = %d [times]\n", n_cal);
			fprintf(fp1, "\tזEO̊gU̕ψړ = %.2f [m]\n", sqrt(2.0*D_ext*DELTA_T));
			fprintf(fp1, "\tזE̊gU̕ψړ = %.2f [m]\n", sqrt(2.0*D_int*DELTA_T));
			fprintf(fp1, "\tiq_ = %d \n", IMG);
			fprintf(fp1, "\tMWJniq_ = %d \n", cs);
			fprintf(fp1, "\tMWIiq_ = %d \n", cl);
			fprintf(fp1, "\tP = %.2f [m/s]\n", P*1.0e3);
			fprintf(fp1, "\t = %.1f [degree] \n", TH);
			fprintf(fp1, "\td = D_int/D_ext = %.3f\n", d);
			fprintf(fp1, "\tj = s_mem/s_ext = %.3f\n", j);
			fprintf(fp1, "\ts_int = %.3f\n", D_int*DELTA_T/(DELTA_X*DELTA_X));
			fprintf(fp1, "\ts_ext = %.3f\n", D_ext*DELTA_T/(DELTA_X*DELTA_X));
			fprintf(fp1, "\ts_mem = %.3f\n", D_ext*DELTA_T/(DELTA_X*DELTA_X)*j);
			fprintf(fp1, "\nG\tGx\tGy\tb\tsignal\n");
			fprintf(fp1, "%.1f\t%.1f\t%.1f\t%.0f\t%f\n", 0.0, 0.0, 0.0, 0.0, 0.0);
			fprintf(fp2, "%.0f\t%f\n", 0.0, 0.0);

//XΎύX郋[v
			for (gg = 1; gg < NG; gg++) {
				Gx = G[gg]*cos(PI*TH/180.0);			//x̌XΎꋭx
				Gy = G[gg]*sin(PI*TH/180.0);			//y̌XΎꋭx
				b = GAMMA*GAMMA*G[gg]*G[gg]*MPG_WIDTH*MPG_WIDTH*(MPG_INTERVAL-MPG_WIDTH/3.0)*1000.0;

//ʑω̐Ɨ]̌vZ
				for (n = 0; n < IMG; n++) {
					for (m = 0; m < IMG; m++) {
						phi = -GAMMA*DELTA_X*DELTA_T*(Gx*(m-IMG/2)+Gy*(IMG/2-n));
						sin_phi[n*IMG+m] = sin(phi);
						cos_phi[n*IMG+m] = cos(phi);
					}
				}
	
//̏	
				for (i = 0; i < IMG*IMG; i++) {
					Mx[i] = 100.0;
					My[i] = 0.0;
				}

//ԂύX郋[v
				count = 0;
				count1 = 0;
				sig_x = 0.0;	
				sig_y = 0.0;
				sig_0 = 0.0;
				sig_TE = 0.0;
				for (n = cs; n < cl; n++) {					//M̌vZ
					for (m = cs; m < cl; m++) {
						sig_0 += sqrt(Mx[n*IMG+m]*Mx[n*IMG+m]+My[n*IMG+m]*My[n*IMG+m]);
					}
				}
				for (t = 0.0; t < TE; t += DELTA_T) {
					printf("\rt=%.1f", t);
					for (n = 0; n < IMG; n++) {
						for (m = 0; m < IMG; m++) {
	
//L@pgǓvZ
							i = n*IMG+m;
							if (n == 0) {
								if (m == 0) {
									dum_Mx[i] = s_right[i]*Mx[i+1]+s_down[i]*Mx[i+IMG]+s_rem[i]*Mx[i];
									dum_My[i] = s_right[i]*My[i+1]+s_down[i]*My[i+IMG]+s_rem[i]*My[i];
								}
								else if (m == IMG-1) {
									dum_Mx[i] = s_left[i]*Mx[i-1]+s_down[i]*Mx[i+IMG]+s_rem[i]*Mx[i];
									dum_My[i] = s_left[i]*My[i-1]+s_down[i]*My[i+IMG]+s_rem[i]*My[i];
								}
								else {
									dum_Mx[i] = s_left[i]*Mx[i-1]+s_right[i]*Mx[i+1]+s_down[i]*Mx[i+IMG]+s_rem[i]*Mx[i];
									dum_My[i] = s_left[i]*My[i-1]+s_right[i]*My[i+1]+s_down[i]*My[i+IMG]+s_rem[i]*My[i];
								}
							}
							else if (n == IMG-1) {
								if (m == 0) {
									dum_Mx[i] = s_right[i]*Mx[i+1]+s_up[i]*Mx[i-IMG]+s_rem[i]*Mx[i];
									dum_My[i] = s_right[i]*My[i+1]+s_up[i]*My[i-IMG]+s_rem[i]*My[i];
								}
								else if (m == IMG-1) {
									dum_Mx[i] = s_left[i]*Mx[i-1]+s_up[i]*Mx[i-IMG]+s_rem[i]*Mx[i];
									dum_My[i] = s_left[i]*My[i-1]+s_up[i]*My[i-IMG]+s_rem[i]*My[i];
								}
								else {
									dum_Mx[i] = s_left[i]*Mx[i-1]+s_right[i]*Mx[i+1]+s_up[i]*Mx[i-IMG]+s_rem[i]*Mx[i];
									dum_My[i] = s_left[i]*My[i-1]+s_right[i]*My[i+1]+s_up[i]*My[i-IMG]+s_rem[i]*My[i];
								}
							}
							else {
								if (m == 0) {
									dum_Mx[i] = s_right[i]*Mx[i+1]+s_up[i]*Mx[i-IMG]+s_down[i]*Mx[i+IMG]+s_rem[i]*Mx[i];
									dum_My[i] = s_right[i]*My[i+1]+s_up[i]*My[i-IMG]+s_down[i]*My[i+IMG]+s_rem[i]*My[i];
								}
								else if (m == IMG-1) {
									dum_Mx[i] = s_left[i]*Mx[i-1]+s_up[i]*Mx[i-IMG]+s_down[i]*Mx[i+IMG]+s_rem[i]*Mx[i];
									dum_My[i] = s_left[i]*My[i-1]+s_up[i]*My[i-IMG]+s_down[i]*My[i+IMG]+s_rem[i]*My[i];
								}
								else {
									dum_Mx[i] = s_left[i]*Mx[i-1]+s_right[i]*Mx[i+1]+s_up[i]*Mx[i-IMG]+s_down[i]*Mx[i+IMG]+s_rem[i]*Mx[i];
									dum_My[i] = s_left[i]*My[i-1]+s_right[i]*My[i+1]+s_up[i]*My[i-IMG]+s_down[i]*My[i+IMG]+s_rem[i]*My[i];
								}
							}
						}
					}
//ʑ̕ω
					for (i = 0; i < IMG*IMG; i++) {
						if (t < MPG_WIDTH) {	
							Mx[i] = dum_Mx[i]*cos_phi[i]-dum_My[i]*sin_phi[i];
							My[i] = dum_My[i]*cos_phi[i]+dum_Mx[i]*sin_phi[i];
						}
						else if (t < MPG_INTERVAL) {
							Mx[i] = dum_Mx[i];
							My[i] = dum_My[i];
						}
						else if (t < MPG_INTERVAL+MPG_WIDTH) {
							Mx[i] = dum_Mx[i]*cos_phi[i]+dum_My[i]*sin_phi[i];
							My[i] = dum_My[i]*cos_phi[i]-dum_Mx[i]*sin_phi[i];
						}
						else {
							Mx[i] = dum_Mx[i];
							My[i] = dum_My[i];
						}
					}
					count++;
				} //end TE
				for (n = cs; n < cl; n++) {
					for (m = cs; m < cl; m++) {
						sig_x += Mx[n*IMG+m];				//̘̎a
						sig_y += My[n*IMG+m];				//̘̎a
					}
				}
				sig_TE = sqrt(sig_x*sig_x+sig_y*sig_y);		//oMx
					printf("\nG>>%.2f Gx>>%.2f Gy>>%.2f b>>%.0f signal>>%f\n", G[gg]*1.0e6, Gx*1.0e6, Gy*1.0e6, b, log(sig_TE/sig_0));
					fprintf(fp1, "%.1f\t%.1f\t%.1f\t%.0f\t%f\n", G[gg]*1.0e6, Gx*1.0e6, Gy*1.0e6, b, log(sig_TE/sig_0));
					fprintf(fp2, "%.0f\t%f\n", b, log(sig_TE/sig_0));
			} //end gg
			fclose(fp1);
			fclose(fp2);
		}//end P
	}//end D_int
	
	free(img_c);
	free(img_D);
	free(Mx);
	free(My);
	free(Mm);
	free(dum_Mx);
	free(dum_My);
	free(s_up);
	free(s_down);
	free(s_left);
	free(s_right);
	free(s_rem);
	free(sin_phi);
	free(cos_phi);

	return(0);
}

void write_data_float(char *fi, float *im, int size)	/*file open and write data*/
{	
	FILE  *fp;

	printf("write data : %s\n", fi);	

	if ((fp = fopen(fi, "wb")) == NULL) {
		fprintf(stderr, "Error :file open[%s] \n", fi);
		exit(1);
	}
	fwrite(im, sizeof(float), size, fp);
	fclose(fp);
}

float s_cal(float c1, float c2, float D1, float D2, float j)
{
	if (c1 == c2) {
		return D1*DELTA_T/(DELTA_X*DELTA_X);
	}
	else{
		if (D1 < D2)									//j̑ΏۂD_ext
			return j*D2*DELTA_T/(DELTA_X*DELTA_X);
		else
			return j*D1*DELTA_T/(DELTA_X*DELTA_X);
	}
}