/*===============================================

  P8-1 normal_char.cpp

 (83(1) ɑΉ)
 Brain Web_E[hT1WI, T2WI, PWI
 3f[^ƂɔCӒfʂ2摜𒊏o
 vOD

 CӒf(Transverse, Sagittal, Coronal)C
 XCXԍݒ肷邱Ƃ\łD

 {vO͌f[^raw byte (unsigned char)
 ̃f[^ɑΉĂCgq[.rawb]̌f[^
 gpKvD

 ftHgł[t1_icbm_normal_1mm_pn0_rf0.rawb]
 f[^Brain Web_E[hC{vO
 ̃tH_ɕۑĂ΁CvOs
 [Enter]NbN邾ŁC^C
 2̉摜[trans_60.img]쐬悤
 ݒ肳ĂD

=================================================*/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define PN	9

typedef struct { // ͕ϐ
	char	f1[50];	/* input file name */
	int		nx;		/* number of original matrix (x) */
	int		ny;		/* number of original matrix (y) */
	int		nz;		/* number of original matrix (z) */
	int		nk;		/* number of after matrix (nk) */
	int		ch;		/* direction of section */
	int		sl;		/* number of slice (slice) */
	char	f2[50]; /* output file name */
} Param;

char *menu[PN] = { // ͂̍ۂ̃Rgi͕ϐƃNj
	"P8-1 normal_char.cpp",
	"Input 3d file name <char>",
	"    Number of matrix  (x)",
	"    Number of matrix  (y)",
	"    Number of matrix  (z)",
	"    Number of matrix  (after)",
	"    Direction of slice (Transverse:1, Sagittal:2, Coronal:3)",
	"    Number of slice   (sl)",
	"Output 2d file name <float>",
};

void getparameter(Param *pm)
{
	int		i;
	char	dat[256];

	/* default parameter value */
	sprintf(pm->f1, "t1_icbm_normal_1mm_pn0_rf0.rawb");
	pm->nx = 181;
	pm->ny = 217;
	pm->nz = 181;
	pm->nk = 256;
	pm->ch = 1;
	pm->sl = 60;
	sprintf(pm->f2, "ax_60.img");

	i = 0;
	fprintf(stdout, "\n%s\n\n", menu[i++]);
	fprintf(stdout, " %s [%s] :", menu[i++], pm->f1);
	if (*gets(dat) != '\0') strcpy(pm->f1, dat);
	fprintf(stdout, " %s [%d] :", menu[i++], pm->nx);
	if (*gets(dat) != '\0') pm->nx = atoi(dat);
	fprintf(stdout, " %s [%d] :", menu[i++], pm->ny);
	if (*gets(dat) != '\0') pm->ny = atoi(dat);
	fprintf(stdout, " %s [%d] :", menu[i++], pm->nz);
	if (*gets(dat) != '\0') pm->nz = atoi(dat);
    fprintf(stdout, " %s [%d] :", menu[i++], pm->nk);
	if (*gets(dat) != '\0') pm->nk = atoi(dat);
	fprintf(stdout, " %s [%d] :", menu[i++], pm->ch);
	if (*gets(dat) != '\0') pm->ch = atoi(dat);
	fprintf(stdout, " %s [%d] :", menu[i++], pm->sl);
	if (*gets(dat) != '\0') pm->sl = atoi(dat);
	fprintf(stdout, " %s [%s] :", menu[i++], pm->f2);
	if (*gets(dat) != '\0') strcpy(pm->f2, dat);
}

void read_slice(unsigned char *, float *, int , int , int , int , int , int);
void swap(unsigned char *, int , int , int);
void read_data_c(char [], unsigned char *, int); 
void write_data_c(char [], unsigned char *, int);
void write_data(char [], float *, int);

/*=======================
		main ֐
 ========================*/
int main(void)
{
	Param	*pm;
	pm = (Param *)malloc(sizeof(Param));
	getparameter(pm);

	int				i;
	float			*img;	// o͉摜(2D)
	unsigned char	*raw;	// ͉摜(3D)

	// ÓI̊m
	raw	= (unsigned char*)malloc((unsigned long)pm->nx*pm->ny*pm->nz*sizeof(unsigned char));
	img	= (float*)malloc((unsigned long)pm->nk*pm->nk*sizeof(float));

	// z̏
	for (i = 0; i < pm->nx*pm->ny*pm->nz; i++) raw[i] = 0;
	for (i = 0; i < pm->nk*pm->nk; i++) img[i] = 0.0;

	// 摜̓ǂݏo (unsigned char^)
	printf("\n ** read image (unsigned char) **\n");
	read_data_c(pm->f1, raw, pm->nx*pm->ny*pm->nz);

    // 3摜̏㉺𔽓]
	printf(" ** padding (under to upper) **\n");
	swap(raw, pm->nx, pm->ny, pm->nz);
	//write_data_c("swap.raw", raw, pm->nx*pm->ny*pm->nz);

    // 3摜Cӂ2fʒo (181~217~181256~256)
	printf(" ** Dumping image (181~217~181256~256) **\n");
	read_slice(raw, img, pm->nx, pm->ny, pm->nz, pm->nk, pm->ch, pm->sl);

	// 摜̏ (float^)
	printf(" ** write image (float) **\n\n");
	write_data(pm->f2, img, pm->nk*pm->nk);

	// ̉
	free(raw);
	free(img);

	return 0;
}

/*=======================
		֐
 ========================*/
/*----------- 3摜̏㉺] ---------------------------*/
void swap(unsigned char *raw, int nx, int ny, int nz)
{
	int				k, i, j;
	unsigned char	*swap;
	
	swap = (unsigned char*)malloc((unsigned long)nx*ny*nz*sizeof(unsigned char));

	for (i = 0; i < nx*ny*nz; i++) swap[i] = 0;

	for (k = 0; k < nz; k++) {
        for (i = 0; i < ny; i++) {
            for (j = 0; j < nx; j++) {
				swap[k*nx*ny+i*nx+j] = raw[(nz-k-1)*nx*ny+(ny-i-1)*nx+j];
			}
		}
	}

	for (i = 0; i < nx*ny*nz; i++) raw[i] = swap[i];
}

/*----------- 3摜Cӂ2fʂ𒊏o ---------------------------*/
void read_slice(unsigned char *raw, float *img, int nx, int ny, int nz, int nk, int ch, int sl)
{
	int		k, i, j, m, n;
	
	switch (ch) {

		// Transverse
		case 1:
            for (i = 0; i < ny; i++) {
                m = nk/2-(ny-1)/2+i;
                for (j = 0; j < nx; j++) {
                    n = nk/2-(nx-1)/2+j;
                    img[m*nk+n] = (float)raw[sl*nx*ny+i*nx+j];
				}
			}
			break;

		// Sagittal
		case 2:
			for (k = 0; k < nz; k++) {
				m = (nk/2)-(nz-1)/2+k;
				for (i = 0; i < ny; i++) {
					n = (nk/2)-(ny-1)/2+i;
					img[m*nk+n] = (float)raw[k*nx*ny+i*nx+sl];
				}
			}
			break;

		// Coronal
		case 3:
			for (k = 0; k < nz; k++) {
				m = (nk/2)-(nz-1)/2+k;
				for (j = 0; j < nx; j++) {
					n = (nk/2)-(nx-1)/2+j;
					img[m*nk+n] = (float)raw[k*nx*ny+sl*nx+j];
				}
			}
			break;

		default:
			printf("<< You had mistake. >>\n");
			exit(1);
	}

}

/*----------- 摜̓ǂݏo (char^) ---------------------------*/
void read_data_c(char fi[], unsigned char *img, int size)
{
	FILE 	*fp;
	if ((fp = fopen(fi, "rb")) == NULL) {
		printf("error input data");
		exit(1);
	}
	fread(img, sizeof(unsigned char), size, fp);
	fclose(fp);
}

/*----------- 摜̏ (char^) ---------------------------*/
void write_data_c(char fi[], unsigned char *img, int size)
{
	FILE 	*fp;
	if ((fp = fopen(fi, "wb")) == NULL) {
		printf("error output data");
		exit(1);
	}
	fwrite(img, sizeof(unsigned char), size, fp);
	fclose(fp);
}

/*----------- 摜̏ (float^) ---------------------------*/
void write_data(char fi[], float *img, int size)
{
	FILE 	*fp;
	if ((fp = fopen(fi, "wb")) == NULL) {
		printf("error output data");
		exit(1);
	}
	fwrite(img, sizeof(float), size, fp);
	fclose(fp);
}