/*----------------------------------------------------
	
	P8-9 fbp_tissue.cpp

	(86(4) ɑΉ)
	<e>
	@ 摜̑vlv
	A 摜3gD̒o CSF(]Ґt), GRY(D, WHI()
	B 摜瓊e̍쐬
	C tB^
	D te
	E č\̉摜3gD̒o
	F (A)(E)̌ʂ̊ԂőΌ덷̑

----------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#define	PAD_X	4			// Value of zero padding (PAD_X=1 is original size of matrixj
#define PAD_Y	1			// Value of zero padding (PAD_Y=1 is original size of matrix)
#define PN		10

typedef struct parameter{
	int		xpix_org;		// Number of matrix (x)
	int		ypix_org;		// Number of matrix (y)
	int		xpix;				// Number of matrix with zero padding (x)
	int		ypix;				// Number of matrix with zero padding (x)
	char	fin[128];		// Input file name
	char	ftis[128];	// Input tissue file name
	char	fout[128];	// Output file name
	int		sw_recfil;	// Reconstruction filter	
}Param;

char *menu[PN] = {
	"P8-9 fbp_tissue.cpp",
	"Input image file name         <float>",
	"Input tissue image file name  <float>",
	"    Number of matrix     (x)   ",
	"    Number of matrix     (y)   ",
	"    Reconstruction Filter",
	"    Ramp(Ramachandran)/Shepp-Logan/None",
	"               (1)   /    (2)   / (0) ",
	"Output image file name         <float>",
};

void pad_ima(float *, float *, int , int , int , int);
void cut_ima(float *, float *, int , int , int , int);
void filter_main(float *, float *, int , int , int);
void ramp_fil(float *, float *, int);
void shepp_logan_fil(float *, float *, int);
void FFT_main(int , float *, float *, int , int);
void FFT(int , float *, float *, float *, float *, int);
void read_data(char [], float *, int);
void write_data(char [], float *, int);
void img_default(float *, float , int);
void radon(float *, int , int);
void back_projection(float *, int , int);
void rotate(float *, int , int , double);
void stan(float *, int);
void clip_tisuue(float *, float *, float *, float , int);
double e1(float *, float *, int);

void getparameter(Param *pm)
{
	int		i;
	char	dat[256];

	/* default parameter value */
	sprintf(pm->fin, "ax_100.img");
	sprintf(pm->ftis, "tissue_ax100.img");
	sprintf(pm->fout, "fbp_ax_100.img");
	pm->xpix_org = 256;
	pm->ypix_org = 256;
	pm->sw_recfil= 1;

	i = 0;
	fprintf(stdout, "\n%s\n\n", menu[i++]);
	fprintf(stdout, " %s [%s] :", menu[i++], pm->fin);
	if (*gets(dat) != '\0') strcpy(pm->fin, dat);
	fprintf(stdout, " %s [%s] :", menu[i++], pm->ftis);
	if (*gets(dat) != '\0') strcpy(pm->ftis, dat);
	fprintf(stdout, " %s [%d] :", menu[i++], pm->xpix_org);
	if (*gets(dat) != '\0') pm->xpix_org = atoi(dat);
	fprintf(stdout, " %s [%d] :", menu[i++], pm->ypix_org);
	if (*gets(dat) != '\0') pm->ypix_org = atoi(dat);
	fprintf(stdout, " %s\n", menu[i++]);
	fprintf(stdout, " %s\n", menu[i++]);
	fprintf(stdout, " %s [%d] :", menu[i++], pm->sw_recfil);
	if (*gets(dat) != '\0') pm->sw_recfil = atoi(dat);
	fprintf(stdout, " %s [%s] :", menu[i++], pm->fout);
	if (*gets(dat) != '\0') strcpy(pm->fout, dat);
}

/*=================================================
	o͊֌WEmain֐
===================================================*/

/*----- main֐@----------------------------------------------*/
int main(void)
{
	Param	*pm;
	pm = (Param *)malloc(sizeof(Param));
	getparameter(pm);

	int			i, j;
	float		org_sum=0.0;						//摜̑fl
	float		rad_sum[256] = {0.0};		//ȇfl
	double	rm_csf=0.0;							//CSFRMSE(%)  
	double	rm_gry=0.0;							//GRYRMSE(%)
	double	rm_whi = 0.0;						//WHIRMSE(%)
	FILE		*fp;

	// [pfBỎfvZ
	pm->xpix = pm->xpix_org*PAD_X;
	pm->ypix = pm->ypix_org*PAD_Y;

	// @摜p̃
	float		*imi, *imo;					//o͉摜
	float		*imir, *imii;				//TCmOipbh܂߂x~ỷ摜,Ƌj
	float		*imor, *imoi;				//č\摜ipbh܂߂x~x̉摜,Ƌj
	
	// AΌ덷p̃
	float		*tis;						//gDʗp̊摜
	float		*or_csf;					//摜]Ґt𒊏o
	float		*or_gry;					//摜D𒊏o
	float		*or_whi;					//摜甒𒊏o
	float		*rc_csf;					//č\]Ґt𒊏o
	float		*rc_gry;					//č\D𒊏o
	float		*rc_whi;					//č\甒𒊏o

	// @F̊m
	imi  = (float *)malloc((unsigned long)pm->xpix_org*pm->ypix_org*sizeof(float));
	imo  = (float *)malloc((unsigned long)pm->xpix_org*pm->xpix_org*sizeof(float));
	imir = (float *)malloc((unsigned long)pm->xpix*pm->ypix*sizeof(float));
	imii = (float *)malloc((unsigned long)pm->xpix*pm->ypix*sizeof(float));
	imor = (float *)malloc((unsigned long)pm->xpix*pm->xpix*sizeof(float));
	imoi = (float *)malloc((unsigned long)pm->xpix*pm->xpix*sizeof(float));

	img_default(imi, 0.0, pm->xpix_org*pm->ypix_org);
	img_default(imo, 0.0, pm->xpix_org*pm->ypix_org);
	img_default(imir, 0.0, pm->xpix*pm->ypix);
	img_default(imii, 0.0, pm->xpix*pm->ypix);
	img_default(imor, 0.0, pm->xpix*pm->xpix);
	img_default(imoi, 0.0, pm->xpix*pm->xpix);

	// AF̊m
	tis    = (float *)malloc((unsigned long)pm->xpix_org*pm->ypix_org*sizeof(float));
	or_csf = (float *)malloc((unsigned long)pm->xpix_org*pm->ypix_org*sizeof(float));
	or_gry = (float *)malloc((unsigned long)pm->xpix_org*pm->ypix_org*sizeof(float));
	or_whi = (float *)malloc((unsigned long)pm->xpix_org*pm->ypix_org*sizeof(float));
	rc_csf = (float *)malloc((unsigned long)pm->xpix_org*pm->ypix_org*sizeof(float));
	rc_gry = (float *)malloc((unsigned long)pm->xpix_org*pm->ypix_org*sizeof(float));
	rc_whi = (float *)malloc((unsigned long)pm->xpix_org*pm->ypix_org*sizeof(float));

	img_default(or_csf, 0.0, pm->xpix_org*pm->ypix_org);
	img_default(or_gry, 0.0, pm->xpix_org*pm->ypix_org);
	img_default(or_whi, 0.0, pm->xpix_org*pm->ypix_org);
	img_default(rc_csf, 0.0, pm->xpix_org*pm->ypix_org);
	img_default(rc_gry, 0.0, pm->xpix_org*pm->ypix_org);
	img_default(rc_whi, 0.0, pm->xpix_org*pm->ypix_org);

	//////////////////////////////////////////
	// 摜̓ǂݏo
	read_data(pm->fin, imi, pm->xpix_org*pm->xpix_org);
	read_data(pm->ftis, tis, pm->xpix_org*pm->xpix_org);
	
	// 摜̑flvZ
	for (i = 0; i < pm->xpix_org*pm->ypix_org; i++)
		org_sum += imi[i];
	printf("\n 摜̑vl : %f\n\n", org_sum);

	// 摜3gD𔲂o
	clip_tisuue(or_csf, tis, imi, 1.0, pm->xpix_org*pm->ypix_org);
	clip_tisuue(or_gry, tis, imi, 2.0, pm->xpix_org*pm->ypix_org);
	clip_tisuue(or_whi, tis, imi, 3.0, pm->xpix_org*pm->ypix_org);

	write_data("or_csf.img", or_csf, pm->xpix_org*pm->ypix_org);
	write_data("or_gry.img", or_gry, pm->xpix_org*pm->ypix_org);
	write_data("or_whi.img", or_whi, pm->xpix_org*pm->ypix_org);

	/*-----------------------
		FBP@
	-------------------------*/
	// 摜̓e쐬
	printf(" --- e̍쐬 ---\n");
	radon(imi, pm->xpix_org, pm->ypix_org);
	write_data("radon.img", imi, pm->xpix_org*pm->ypix_org);

	/*---------- ȇfl ()---------------------------*/	
	// e̊epxɂ鑍fl
	for (i = 0; i < pm->ypix_org; i++) {
		for (j = 0; j < pm->xpix_org; j++) {
			rad_sum[i] += imi[i*pm->xpix_org+j];
		}
	}
	
	// ȇflExcel dataŏo
	if ((fp = fopen("data.xls", "wt")) == NULL) {
		fprintf(stderr, "Error:file open\n");
		exit(1);
	}
	fprintf(fp, "fl\n\n");
	fprintf(fp, "摜\t%f\n\n", org_sum);
	fprintf(fp, "eԍ\n");
	for (i = 0; i < pm->ypix_org; i++) {
		fprintf(fp, "%d\t%f\r", i, rad_sum[i]);
	}
	/*---------- ȇfl (܂) ---------------------------*/

	printf(" --- tB^ ---\n");
	// ẽ[pfBO
	pad_ima(imi, imir, pm->xpix_org, pm->ypix_org, pm->xpix, pm->ypix); //
	img_default(imii, 0.0, pm->xpix*pm->ypix);							//

	// ef[^1DFFT
	FFT_main(1, imir, imii, pm->xpix, pm->ypix);

	// č\tB^
	filter_main(imir, imii, pm->xpix, pm->ypix, pm->sw_recfil);

	// ef[^1DIFFT
	FFT_main(-1, imir, imii, pm->xpix, pm->ypix);

	// pbh̐؂(imirimi(ǂݏoeɏ㏑), ͕sv)
	cut_ima(imir, imi, pm->xpix, pm->ypix, pm->xpix_org, pm->ypix_org);
	write_data("ramp_fil.img", imi, pm->xpix_org*pm->ypix_org);

	// te
	printf(" --- te ---\n");
	back_projection(imi, pm->xpix_org, pm->ypix_org);

	// č\s\ȗ]ȕ̃Jbg
	stan(imi, pm->xpix_org);

	// 摜̏
	printf(" --- 摜̏ ---\n");
	write_data(pm->fout, imi, pm->xpix_org*pm->ypix_org);
	
	// č\摜3gD𔲂o
	clip_tisuue(rc_csf, tis, imi, 1.0, pm->xpix_org*pm->ypix_org);
	clip_tisuue(rc_gry, tis, imi, 2.0, pm->xpix_org*pm->ypix_org);
	clip_tisuue(rc_whi, tis, imi, 3.0, pm->xpix_org*pm->ypix_org);

	write_data("rc_csf.img", rc_csf, pm->xpix_org*pm->ypix_org);
	write_data("rc_gry.img", rc_gry, pm->xpix_org*pm->ypix_org);
	write_data("rc_whi.img", rc_whi, pm->xpix_org*pm->ypix_org);

	// Ό덷̌vZ
	rm_csf = e1(or_csf, rc_csf, pm->xpix_org*pm->ypix_org);
	rm_gry = e1(or_gry, rc_gry, pm->xpix_org*pm->ypix_org);
	rm_whi = e1(or_whi, rc_whi, pm->xpix_org*pm->ypix_org);

	printf(" >> Ό덷 ()\n");
	printf(" csf = %f, gry = %f, whi = %f\n", rm_csf, rm_gry, rm_whi);

	// ̉
	free(imi);
	free(imir);
	free(imii);
	free(imor);
	free(imoi);
	free(imo);
	free(pm);
	free(tis);
	free(or_csf);
	free(or_gry);
	free(or_whi);
	free(rc_csf);
	free(rc_gry);
	free(rc_whi);

	return 0;
}

/*----------- gD摜̒o ---------------------------*/
void clip_tisuue(float *cut, float *tis, float *img, float num, int pix)
{
	int		i;

	for (i = 0; i < pix; i++) {
		if (tis[i] == num)
			cut[i] = img[i];
		else
			cut[i] = 0.0;
	}
}

/*---------- Ό덷 (%)@xo:QƒlCxc:ϑl ----------*/
double e1(float *xo, float *xc, int pix)
{
	int     i;
	double	total, total0, e1;

	total = total0 = 0.0;
	
	// Ό덷̌vZ@
	for (i = 0; i < pix; i++) {
		total  += fabs(xc[i]-xo[i]);
		total0 += xo[i];
	}

	e1 = 100.0*total/total0;

	return e1;
}


/*----- 摜̓ǂݏo -----------------------------------------*/
void read_data(char fi[], float *img, int size)
{	
	FILE	*fp;
	if ((fp = fopen(fi, "rb")) == NULL) {
		printf("error input data");
		exit(1);
	}
	fread(img, sizeof(float), size, fp);
	fclose(fp);
}
/*----- 摜̏ -----------------------------------------*/
void write_data(char fi[], float *img, int size)
{
	FILE	*fp;
	if ((fp = fopen(fi, "wb")) == NULL) {
		printf("error output data");
		exit(1);
	}
	fwrite(img, sizeof(float), size, fp);
	fclose(fp);
}
/*----- 摜̏ -------------------------------------------*/
void img_default(float *im, float value, int pix)
{
	int		i;

	for (i = 0; i < pix; i++)
		im[i] = value;
}

/*=================================================
	t[GϊEtϊi1j
=================================================*/

/*----- 1t[GϊiyJԂj ---------------------*/
void FFT_main(int sw, float *imr, float *imi, int xpix, int ypix)
{
	int		i,j;
	float	*im1r, *im1i;	//CoiDFT͑,Ej
	float	*im2r, *im2i;	//CoiDFTo͑,Ej

	//̊m
	im1r = (float *)malloc((unsigned long)xpix*sizeof(float));
	im1i = (float *)malloc((unsigned long)xpix*sizeof(float));
	im2r = (float *)malloc((unsigned long)xpix*sizeof(float));
	im2i = (float *)malloc((unsigned long)xpix*sizeof(float));


	//JԂZ
	for (i = 0; i < ypix; i++) {
		//Coi͑j̍쐬
		for (j = 0; j < xpix; j++) {
			im1r[j] = imr[i*xpix+j];
			im1i[j] = imi[i*xpix+j];
		}
		//Ut[Gϊ
		FFT(sw, im1r, im1i, im2r, im2i, xpix);

		//摜ւƖ߂i㏑j
		for (j = 0; j < xpix; j++) {
			imr[i*xpix+j] = im2r[j];
			imi[i*xpix+j] = im2i[j];
		}
	}
	free(im1r);
	free(im1i);
	free(im2r);
	free(im2i);
}

/*----- 1FFT ---------------------*/
void FFT(int ir, float *fr, float *fi, float *fr2, float *fi2, int nx)
{
	int		*ibr, l, n2, r, pair, m, n, i, j;
	float	buff;
	int		a;
	double	w1, w2, co, si;
	float	pi;

	ibr = (int *)malloc((unsigned long)nx*sizeof(int));
	pi = (float)acos(-1.0);
	
	a = 1;
	if (ir == -1) a = nx;

	for (i = 0; i < nx; i++)
		fr2[i] = fi2[i] = 0.0;

	for (i = 0; i < nx/2; i++) {
		buff = fr[i];
		fr[i] = fr[i+nx/2];
		fr[i+nx/2] = buff;
	}

	for (i = 0; i < nx/2; i++) {
		buff = fi[i];
		fi[i] = fi[i+nx/2];
		fi[i+nx/2] = buff;
	}

	r = (int)(log((double) nx)/log((double) 2));

	for (l = 1; l <= r; l++) {
		pair = (int)(pow(2.0, (double)(l-1)));
		n2 = nx/(int)(pow(2.0, (double)l));

		for (i = 0; i < nx; i++) ibr[i] = 0;
		for (i = 0; i<l; i++) {
			m = nx/(int)(pow(2.0, (double)l))*(int)(pow(2.0, (double)i));
			n = m*2;
			for (j = m; j < n; j++) {
				ibr[j] = ibr[j-m]+nx/(int)(pow(2.0, (double) i+1));
			}
		}

		for (i = 0; i < pair; i++) {
			for (j = n2*i*2; j < n2*i*2+n2; j++) {
				co = cos(2*pi*ibr[j]/nx);
				si = sin(2*pi*ibr[j]/nx);
				w1 = co*fr[j+n2]+ir*si*fi[j+n2];
				w2 = -ir*si*fr[j+n2]+co*fi[j+n2];
				fr[j+n2] = (float)(fr[j]-w1);
				fi[j+n2] = (float)(fi[j]-w2);
				fr[j] = (float)(fr[j]+w1);
				fi[j] = (float)(fi[j]+w2);
			}
		}
	}

	for (i = 0; i < nx; i++) {
		fr[i] = fr[i]/a;
		fi[i] = fi[i]/a;
	}
    
	for (i = 0; i < nx; i++) {
		for (j = 0; j < nx; j++) {
			if (i == ibr[j]) fr2[i] = fr[j];
		}
	}

	for (i = 0; i < nx/2; i++) {
		buff = fr2[i];
		fr2[i] = fr2[i+nx/2];
		fr2[i+nx/2] = buff;
	}

	for (i = 0; i < nx; i++) {
		for (j = 0; j < nx; j++) {
			if (i == ibr[j]) fi2[i] = fi[j];
		}
	}

	for (i = 0; i < nx/2; i++) {
		buff = fi2[i];
		fi2[i] = fi2[i+nx/2];
		fi2[i+nx/2] = buff;
	}

	free(ibr);
}

/*----- tB^Omain -----------------------------------*/
void filter_main(float *imr, float *imi, int xpix, int ypix, int type)
{
	int		i, j, pix;
	float	*imtr, *imti;	//Co

	//召ʁixEyj
	if (xpix >= ypix)	pix = xpix;	//f̑mۂ邽߁ixpixypixł\ɂ邽߁j
	else				pix = ypix;

	//̊m
	imtr = (float *)malloc((unsigned long)pix*sizeof(float));
	imti = (float *)malloc((unsigned long)pix*sizeof(float));

	//x̌JԂZ
	for (i = 0; i < ypix; i++) {
		//Coi͑j̍쐬
		for (j = 0; j < xpix; j++) {
			imtr[j] = imr[i*xpix+j];
			imti[j] = imi[i*xpix+j];
		}
		//tB^(type='r':ramp filterAtype='s':Shepp-Logan filter)
		if (type == 1)	ramp_fil(imtr, imti, xpix);
		if (type == 2)	shepp_logan_fil(imtr, imti, xpix);
		//摜ւƖ߂i㏑j
		for (j = 0; j < xpix; j++) {
			imr[i*xpix+j] = imtr[j];
			imi[i*xpix+j] = imti[j];
		}
	}

	free(imtr);
	free(imti);
}


/*=================================================
	̑
=================================================*/

/*----- [pfBO ---------------------------------------*/
void pad_ima(float *imi, float *imo, int ixpx, int iypx, int oxpx, int oypx)
{
	int		i, j;
	
    img_default(imo, 0.0, oxpx*oypx);
	for (i = -iypx/2; i < iypx/2; i++) {
		for (j = -ixpx/2; j < ixpx/2; j++)
			imo[(i+oypx/2)*oxpx+j+oxpx/2] = imi[(i+iypx/2)*ixpx+j+ixpx/2];
	}
}

/*----- pbh̐؂ -----------------------------------*/
void cut_ima(float *imi, float *imo, int ixpx, int iypx, int oxpx, int oypx)
{
	int		i, j;

	for (i = -oypx/2; i < oypx/2; i++) {
		for (j = -oxpx/2; j < oxpx/2; j++)
			imo[(i+oypx/2)*oxpx+j+oxpx/2] = imi[(i+iypx/2)*ixpx+j+ixpx/2];
	}
}

/*----- ramptB^igԁj -----------------------------*/
void ramp_fil(float *imr, float *imi, int pix)
{
	int		i, imc;
	float	f;

	imc = (int)(pix/2);

	for (i = 0; i < pix; i++) {
		f = (float)i-imc;
		f = (float)fabs(f)/pix;   // filteřvZ

		imr[i] *= f;
		imi[i] *= f;
	}
}

/*----- Shepp-LogantB^igԁj ----------------------*/
void shepp_logan_fil(float *imr, float *imi, int pix)
{
	int		i, imc;
	float	pi, f, hw;

	imc = (int)(pix/2);
	pi = (float)acos(-1.0);

	for (i = 0; i < pix; i++) {
		f = (float)(fabs((double)(i-imc))/pix);
		hw = (float)(sin(pi*f)/pi);
		imr[i] *= hw;
		imi[i] *= hw;
	}
}


/*=================================================
	eEteE]
=================================================*/

/*----- e ----------------------------------------*/
void radon(float *img1, int nx, int ny)
{
	int		i, j, k;
	double	th;
	float	*img2, *img3 ;

	img2 = (float *)malloc((unsigned long)nx*ny*sizeof(float));
	img3 = (float *)malloc((unsigned long)nx*ny*sizeof(float));

	for (i = 0; i < nx*ny; i++) 
		img2[i] = img3[i] = 0.0;

	for (k = 0; k < ny; k++) {
		th = (double)(k*360/ny);
		for (i = 0; i < nx*ny; i++) {
			img3[i] = img1[i];
		}
		rotate(img3, nx, ny, th);

		for (j = 0; j < nx; j++) {
			for (i = 0; i < ny; i++) {
				img2[k*nx+j] += img3[i*nx+j];
			}
		}
	}
	for (i = 0; i < nx*ny; i++) img1[i] = img2[i];
	
	free(img2);
	free(img3);
}

/*----- te ----------------------------------------*/
void back_projection(float *img1, int nx, int ny)
{
	int		i, j, m, x1;
	float	*img2;
	float	pi;
	double	th, x, y, dx1, dx2, x0;
	
	img2 = (float *)malloc((unsigned long)nx*ny*sizeof(float));
	pi = (float)acos(-1.0);

	for (i = 0; i < nx*ny; i++) 
		img2[i] = 0.0;

	for (i = 0; i < ny; i++) {
		y = (double)ny/2-i;
		for (j = 0; j < nx; j++) {
			x = (double)j-nx/2;
			for (m = 0; m < ny; m++) {
				th  = (double)m*360/ny;
				th *= (double)(pi/180);

				x0 = (double)x*cos(th)+y*sin(th)+(double)nx/2;
				x1 = (int)x0;
				dx1 = (double)x0-x1;
				dx2 = (double)1-dx1;

				if (x1 > 0 && x1  < nx-1) {
					img2[i*nx+j] += (float)(dx1*img1[m*nx+x1+1]+dx2*img1[m*nx+x1]);
				}
			}
		}
	}
	for (i = 0; i < nx*ny; i++)
		img1[i] = pi*img2[i]/ny;

	free(img2);
}

/*----- ] ----------------------------------------*/
void rotate(float *img, int nx, int ny, double th)
{
	int     i, j, i0, j0, i1, j1;
	double  x0, y0, si, co;
	float   *ima;
	float   pi;

	ima = (float *)malloc((unsigned long)nx*ny*sizeof(float));
	pi = (float)acos(-1.0);
	co = cos(th*pi/180);
	si = sin(th*pi/180);

	for (i = 0; i < nx*ny; i++) 
		ima[i] = 0.0;

	for (i = 0; i < ny; i++) {
		for (j = 0; j < nx; j++) {
			x0 = (j-nx/2)*co-(ny/2-i)*si+nx/2;
			j0 = (int)x0;
			j1 = j0+1;
			y0 = -(j-nx/2)*si-(ny/2-i)*co+ny/2;
			i0 = (int)y0;
			i1 = i0+1;

			if (i0 >= 0 && i1 < ny && j0 >= 0 && j1 < nx) {
				ima[i*nx+j] = (float)((j1-x0)*(i1-y0)*img[i0*nx+j0]
				            +(x0-j0)*(i1-y0)*img[i0*nx+j1]
							+(j1-x0)*(y0-i0)*img[i1*nx+j0]
							+(x0-j0)*(y0-i0)*img[i1*nx+j1]);
			}
			else{ 
				ima[i*nx+j] = 0.0;
			}
		}
	}

	for (i = 0; i < nx*ny; i++) 
		img[i] = ima[i];

	free(ima);
}

/*----- KiEXV ---------------------------------*/
void stan(float *imi, int spix)
{
	int		i, j;
	float	imc, x, y;

	imc = (float)(spix/2.0);	//摜̒S

	for (i = 0; i < spix; i++) {
		for (j = 0; j < spix; j++) {
            y = (float)(imc-i-1);
			x = (float)(j-imc);

			//Ki
			if (x*x+y*y < imc*imc)
			{
				imi[i*spix+j] *= 1.0;
			}
			else
				imi[i*spix+j] = (float)0.0;
		}
	}
}
