/*===============================================

  P8-5 fuzzy_char.cpp

 (84(2) ɑΉ)
 Brain Web_E[hFuzzy Model
 3f[^ƂɔCӒfʂ̊ɘaԒlC
 ̓vgxl2摜𒊏o
 vOD

 CӒf(Transverse, Sagittal, Coronal)C
 XCXԍݒ肷邱Ƃ\łD

 {vO͌f[^raw byte (unsigned char)
 ̃f[^ɑΉĂCgq[.rawb]̌f[^
 gpKvD

 ftHgł[phantom_1.0mm_normal_csf.rawb]
 f[^Brain Web_E[hC{vO
 ̃tH_ɕۑĂ΁CvOs
 [Enter]NbN邾ŁC^C
 2̉摜[t1trans_csf_60.img]쐬悤
 ݒ肳ĂD

=================================================*/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define PN	24
#define N	10

typedef struct { // ͕ϐ
	char	f1[50];	/* input file name */
	int		nx;		/* number of original matrix (x) */
	int		ny;		/* number of original matrix (y) */
	int		nz;		/* number of original matrix (z) */
	int		nk;		/* number of after matrix (nk) */
	int		kt;		/* kind of tissue */
	int		ti;		/* kind of image (T1:1, T2:2, T2*:3, PD:4) */
	int		ch;		/* direction of section */
	int		sl;		/* number of slice (slice) */
	char	f2[50]; /* output file name */
} Param;

typedef struct { // egD̏
	float   t1;		/* Value of T1(ms) */
	float	t2;		/* Value of T2(ms) */
	float	ts2;	/* Value of T2*(ms) */
	float	pd;		/* Value of PD */
} Tissue;

char *menu[PN] = { // ͂̍ۂ̃Rgi͕ϐƃNj
	"P8-5 fuzzy_char.cpp",
	"Input 3d file name <char>",
	"    Number of matrix  (x)",
	"    Number of matrix  (y)",
	"    Number of matrix  (z)",
	"    Number of matrix  (after)",
	"     Kind of tissue",
	"		* BACKGROUND   : 0",
	"		* CSF          : 1",
	"		* GREY MATTER  : 2",
	"		* WHITE MATTER : 3",
	"		* FAT          : 4",
	"		* MUSCLE/SKIN  : 5",
	"		* SKIN         : 6",
	"		* SKULL        : 7",
	"		* Glial MATTER : 8",
	"		* MEAT         : 9",
	"	 --------------------------->>",
	"     Kind of image",
	"		(T1:1, T2:2, T2*:3, PD:4)      ",
	"     Direction of slice",
	"		(Transverse:1, Sagittal:2, Coronal:3) ",
	"    Number of slice   (sl)",
	"Output 2d file name <float>",
};

void getparameter(Param *pm)
{
	int		i;
	char	dat[256];

	/* default parameter value */
	sprintf(pm->f1, "phantom_1.0mm_normal_csf.rawb");
	pm->nx = 181;
	pm->ny = 217;
	pm->nz = 181;
	pm->nk = 256;
	pm->kt = 1;
	pm->ti = 1;
	pm->ch = 1;
	pm->sl = 60;
	sprintf(pm->f2, "t1ax_csf_60.img");

	i = 0;
	fprintf(stdout, "\n%s\n\n", menu[i++]);
	fprintf(stdout, " %s [%s] :", menu[i++], pm->f1);
	if (*gets(dat) != '\0') strcpy(pm->f1, dat);
	fprintf(stdout, " %s [%d] :", menu[i++], pm->nx);
	if (*gets(dat) != '\0') pm->nx = atoi(dat);
	fprintf(stdout, " %s [%d] :", menu[i++], pm->ny);
	if (*gets(dat) != '\0') pm->ny = atoi(dat);
	fprintf(stdout, " %s [%d] :", menu[i++], pm->nz);
	if (*gets(dat) != '\0') pm->nz = atoi(dat);
    fprintf(stdout, " %s [%d] :", menu[i++], pm->nk);
	if (*gets(dat) != '\0') pm->nk = atoi(dat);
	fprintf(stdout, "%s\n", menu[i++]);
	fprintf(stdout, "%s\n", menu[i++]);
	fprintf(stdout, "%s\n", menu[i++]);
	fprintf(stdout, "%s\n", menu[i++]);
	fprintf(stdout, "%s\n", menu[i++]);
    fprintf(stdout, "%s\n", menu[i++]);
	fprintf(stdout, "%s\n", menu[i++]);
	fprintf(stdout, "%s\n", menu[i++]);
	fprintf(stdout, "%s\n", menu[i++]);
	fprintf(stdout, "%s\n", menu[i++]);
    fprintf(stdout, "%s\n", menu[i++]);
    fprintf(stdout, " %s [%d] :", menu[i++], pm->kt);
	if (*gets(dat) != '\0') pm->kt = atoi(dat);
	fprintf(stdout, "%s\n", menu[i++]);
	fprintf(stdout, " %s [%d] :", menu[i++], pm->ti);
	if (*gets(dat) != '\0') pm->ti = atoi(dat);
	fprintf(stdout, "%s\n", menu[i++]);
	fprintf(stdout, " %s [%d] :", menu[i++], pm->ch);
	if (*gets(dat) != '\0') pm->ch = atoi(dat);
	fprintf(stdout, " %s [%d] :", menu[i++], pm->sl);
	if (*gets(dat) != '\0') pm->sl = atoi(dat);
	fprintf(stdout, " %s [%s] :", menu[i++], pm->f2);
	if (*gets(dat) != '\0') strcpy(pm->f2, dat);
}

void setparameter(Tissue *tiss)
{
	// BACKGROUND
	tiss[0].t1   = 0.0;
	tiss[0].t2   = 0.0;
	tiss[0].ts2  = 0.0;
	tiss[0].pd   = 0.0;

	// CSF
	tiss[1].t1   = 2569.0;
	tiss[1].t2   = 329.0;
	tiss[1].ts2  = 58.0;
	tiss[1].pd   = 1.0;
	
	// GREY MATTER
	tiss[2].t1   = 833.0;
	tiss[2].t2   = 83.0;
	tiss[2].ts2  = 69.0;
	tiss[2].pd   = 0.86;

	// WHITE MATTER
	tiss[3].t1   = 500.0;
	tiss[3].t2   = 70.0;
	tiss[3].ts2  = 61.0;
	tiss[3].pd   = 0.77;

	// FAT
	tiss[4].t1   = 350.0;
	tiss[4].t2   = 70.0;
	tiss[4].ts2  = 58.0;
	tiss[4].pd   = 1.0;

	// MUSCLE / SKIN
	tiss[5].t1   = 900.0;
	tiss[5].t2   = 47.0;
	tiss[5].ts2  = 30.0;
	tiss[5].pd   = 1.0;
	
	// SKIN
	tiss[6].t1   = 2569.0;
	tiss[6].t2   = 329.0;
	tiss[6].ts2  = 58.0;
	tiss[6].pd   = 1.00;

	// SKULL
	tiss[7].t1   = 0.0;
	tiss[7].t2   = 0.0;
	tiss[7].ts2  = 0.0;
	tiss[7].pd   = 0.0;
	
	// Glial MATTER
	tiss[8].t1   = 833.0;
	tiss[8].t2   = 83.0;
	tiss[8].ts2  = 69.0;
	tiss[8].pd   = 1.86;

	// MEAT
	tiss[9].t1   = 500.0;
	tiss[9].t2   = 70.0;
	tiss[9].ts2  = 61.0;
	tiss[9].pd   = 0.77;
}

void read_slice(unsigned char *, float *, int , int , int , int , int , int);
void swap(unsigned char *, int , int , int);
void plot_value_t(Tissue *, float *, int , int , int , int);
void read_data_c(char [], unsigned char *, int); 
void write_data_c(char [], unsigned char *, int);
void write_data(char [], float *, int);

/*=======================
		main ֐
 ========================*/

int main(void)
{
	Param	*pm;
	pm = (Param *)malloc(sizeof(Param));
	getparameter(pm);

	Tissue	*tiss;
	tiss = (Tissue *)malloc(N*sizeof(Tissue));
	setparameter(tiss);

	int				i;
	float			*img;	// o͉摜(2D)
	unsigned char	*raw;	// ͉摜(3D)

	// ÓI̊m
	raw	= (unsigned char*)malloc((unsigned long)pm->nx*pm->ny*pm->nz*sizeof(unsigned char));
	img	= (float*)malloc((unsigned long)pm->nk*pm->nk*sizeof(float));
	
	// z̏
	for (i = 0; i < pm->nx*pm->ny*pm->nz; i++) raw[i] = 0;
	for (i = 0; i < pm->nk*pm->nk; i++) img[i] = 0.0;

	// 摜̓ǂݏo (unsigned char^)
	printf("\n ** read image (unsigned char) **\n");
	read_data_c(pm->f1, raw, pm->nx*pm->ny*pm->nz);

    // 3摜̏㉺𔽓]
	printf(" ** padding (under to upper) **\n");
	swap(raw, pm->nx, pm->ny, pm->nz);
	//write_data_c("swap.raw", raw, pm->nx*pm->ny*pm->nz);

    // 3摜Cӂ2fʒo (181~217~181256~256)
	printf(" ** Dumping image (181~217~181256~256) **\n");
	read_slice(raw, img, pm->nx, pm->ny, pm->nz, pm->nk, pm->ch, pm->sl);

    // gDʂɊɘaԁCvgx
	printf(" ** Plot vale of tissue **\n");
	plot_value_t(tiss, img, pm->nk, pm->nk, pm->kt, pm->ti);

	// 摜̏ (float^)
	printf(" ** write image (float) **\n\n");
	write_data(pm->f2, img, pm->nk*pm->nk);

	// ̉
	free(raw);
	free(img);

	return 0;
}

/*=======================
		֐
 ========================*/
/*----------- 3摜̏㉺] ---------------------------*/
void swap(unsigned char *raw, int nx, int ny, int nz)
{
	int				k, i, j;
	unsigned char	*swap;
	
	swap = (unsigned char*)malloc((unsigned long)nx*ny*nz*sizeof(unsigned char));

	for (i = 0; i < nx*ny*nz; i++)	swap[i] = 0;

	for (k = 0; k < nz; k++) {
        for (i = 0; i < ny; i++) {
            for (j = 0; j < nx; j++) {
				swap[k*nx*ny+i*nx+j] = raw[(nz-k-1)*nx*ny+(ny-i-1)*nx+j];
			}
		}
	}

	for (i = 0; i < nx*ny*nz; i++) raw[i] = swap[i];
}

/*----------- 3摜Cӂ2fʂ𒊏o ---------------------------*/
void read_slice(unsigned char *raw, float *img, int nx, int ny, int nz, int nk, int ch, int sl)
{
	int		k, i, j, m, n;
	
	switch (ch) {

		// Transverse
		case 1:
            for (i = 0; i < ny; i++) {
                m = nk/2-(ny-1)/2+i;
                for (j = 0; j < nx; j++) {
                    n = nk/2-(nx-1)/2+j;
                    img[m*nk+n] = (float)raw[sl*nx*ny+i*nx+j];
				}
			}
			break;

		// Sagittal
		case 2:
			for (k = 0; k < nz; k++) {
				m = (nk/2)-(nz-1)/2+k;
				for (i = 0; i < ny; i++) {
					n = (nk/2)-(ny-1)/2+i;
					img[m*nk+n] = (float)raw[k*nx*ny+i*nx+sl];
				}
			}
			break;

		// Coronal
		case 3:
			for (k = 0; k < nz; k++) {
				m = (nk/2)-(nz-1)/2+k;
				for (j = 0; j < nx; j++) {
					n = (nk/2)-(nx-1)/2+j;
					img[m*nk+n] = (float)raw[k*nx*ny+sl*nx+j];
				}
			}
			break;

		default:
			printf("\n\n<< You had mistake. >>\n\n");
			exit(1);
	}
}

/*----------- 2摜f[^֊ɘaԂ ---------------------------*/
void plot_value_t(Tissue *tiss, float *img, int nx, int ny, int kt, int ti)
{
	int		i;

	if (kt > 9) {
        printf("\n\n<< You had mistake. >>\n\n");
		exit(1);
	}
	
	switch (ti) {

		// T1
		case 1:
            for (i = 0; i < nx*ny; i++) {
				if (img[i] == 0.0) img[i] = 0.0;
				else img[i] = tiss[kt].t1;
			}
			break;

        // T2
		case 2:
            for (i = 0; i < nx*ny; i++) {
				if (img[i] == 0.0) img[i] = 0.0;
				else img[i] = tiss[kt].t2;
			}
			break;

		// T2*
		case 3:
             for (i = 0; i < nx*ny; i++) {
				if (img[i] == 0.0) img[i] = 0.0;
				else img[i] = tiss[kt].ts2;
			}
			break;

		// PD
		case 4:
             for (i = 0; i < nx*ny; i++) {
				if (img[i] == 0.0) img[i] = 0.0;
				else img[i] = tiss[kt].pd;
			}
			break;

		default:
			printf("\n\n<< You had mistake. >>\n\n");
			exit(1);
	}
}

/*----------- 摜̓ǂݏo (char^) ---------------------------*/
void read_data_c(char fi[], unsigned char *img, int size)
{
	FILE 	*fp;
	if ((fp = fopen(fi, "rb")) == NULL) {
		printf("error input data");
		exit(1);
	}
	fread(img, sizeof(unsigned char), size, fp);
	fclose(fp);
}

/*----------- 摜̏ (char^) ---------------------------*/
void write_data_c(char fi[], unsigned char *img, int size)
{
	FILE 	*fp;
	if ((fp = fopen(fi, "wb")) == NULL) {
		printf("error output data");
		exit(1);
	}
	fwrite(img, sizeof(unsigned char), size, fp);
	fclose(fp);
}

/*----------- 摜̏ (float^) ---------------------------*/
void write_data(char fi[], float *img, int size)
{
	FILE 	*fp;
	if ((fp = fopen(fi, "wb")) == NULL) {
		printf("error output data");
		exit(1);
	}
	fwrite(img, sizeof(float), size, fp);
	fclose(fp);
}